import IElement from '../../../nodes/element/IElement';
import CSSStyleDeclarationPropertyManager from './CSSStyleDeclarationPropertyManager';
/**
 * CSS Style Declaration utility
 */
export default class CSSStyleDeclarationElementStyle {
    private cache;
    private element;
    private computed;
    /**
     * Constructor.
     *
     * @param element Element.
     * @param [computed] Computed.
     */
    constructor(element: IElement, computed?: boolean);
    /**
     * Returns element style properties.
     *
     * @returns Element style properties.
     */
    getElementStyle(): CSSStyleDeclarationPropertyManager;
    /**
     * Returns style sheets.
     *
     * @param element Element.
     * @returns Style sheets.
     */
    private getComputedElementStyle;
    /**
     * Applies CSS text to elements.
     *
     * @param options Options.
     * @param options.elements Elements.
     * @param options.cssRules CSS rules.
     * @param [options.hostElement] Host element.
     */
    private parseCSSRules;
    /**
     * Returns CSS value.
     *
     * @param value Value.
     * @param cssVariables CSS variables.
     * @returns CSS value.
     */
    private getCSSValue;
}
